#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <string.h>
#include <sys/ioctl.h>
#include "ch37x_lib.h"

#define CH37XDEBUG	

static char devname[20];
static bool bufmode = false;
static int fds[10];
static char devs[10][20];

/* device open/close */

// ɨ赱ǰϵͳȡ豸
int CH37XScanDevices()
{
    int num = 0;
    int i = 0;
    
    while (i < 20) {
    	memset(devname, 0, sizeof(devname));
    	sprintf(devname, "%s%d", "/dev/ch37x", i);
	printf("devname: %s\n", devname);
    	if (!access(devname, F_OK | W_OK | R_OK)) {
    	    memcpy(devs[num], devname, strlen(devname));
            num++;
        }
	i++;
    }
	
    return num;
}

// CH37X豸,ɹtrue
bool CH37XOpenDevice(
	unsigned long iIndex)    // ָCH37X豸
{
    char path[20];
    int fd = -1;
        
    fd = open(devs[iIndex], O_RDWR);
    if (fd < 0)
        return false;
    fds[iIndex] = fd;
    
    return true;
}

// رCH37X豸,ɹtrue
bool CH37XCloseDevice(
	unsigned long iIndex)    // ָCH37X豸
{
    if (fds[iIndex] > 0) {
        if (close(fds[iIndex]) == 0)
            return true;
    }
    
    return false;
}

/* device and driver messages */

// ָCH37X豸ƵĻ,򷵻NULL
void *CH37XGetDeviceName(
	unsigned long iIndex)       // ָCH37X豸,0Ӧһ豸
{
	return devs[iIndex];
}

// ȡ汾
bool CH37XGetDriverVersion(
	unsigned long iIndex,       // ָCH37X豸
	void *oBuffer)              // ָһ㹻Ļ,ڱ豸ID
{
	int retval = 0;

	retval = ioctl(fds[iIndex], GetVersion, (unsigned long)oBuffer);
	if (retval >= 0)
		return 0;
	else
		return retval;
}

// ȡ豸ID
bool CH37XGetDeviceID(
	unsigned long iIndex,       // ָCH37X豸
	unsigned int *id)           // ָһintͱ,ڱ豸ID,16λ-vid16λ-pid
{
	int retval = 0;

	retval = ioctl(fds[iIndex], GetDeviceID, (unsigned long)id);
	if (retval >= 0)
		return 0;
	else
		return retval;
}

// ȡ豸˵Ϣ
bool CH37XGetDeviceMsg(
	unsigned long iIndex,       // ָCH37X豸
	unsigned int *msg)          // ָһintͱ,ڱ˵Ϣ,ֱΪ˵㡢
{
	int retval = 0;

	retval = ioctl(fds[iIndex], GetDeviceMsg, (unsigned long)msg);
	if (retval >= 0)
		return 0;
	else
		return retval;
}

// ȡ豸
bool CH37XGetDeviceDescr(
	unsigned long iIndex,       // ָCH37X豸
	char *version)              // ָһ㹻Ļ,ڱ
{
	int retval = 0;

	retval = ioctl(fds[iIndex], GetDeviceDes, (unsigned long)version);
	if (retval >= 0)
		return 0;
	else
		return retval;
}

/* device data control */

// USBݶдĳʱ
bool CH37XSetTimeout (  
	unsigned long iIndex,           // ָCH37X豸
	unsigned long iWriteTimeout,    // ָUSBдݿĳʱʱ,ԺmSΪλ,0xFFFFFFFFָʱ(Ĭֵ)
	unsigned long iReadTimeout)     // ָUSBȡݿĳʱʱ,ԺmSΪλ,0xFFFFFFFFָʱ(Ĭֵ)
{
	int retval = 0;
	struct {
		unsigned long read;
		unsigned long write;
	} timeout;

	timeout.read = (unsigned long)&iReadTimeout;
	timeout.write = (unsigned long)&iWriteTimeout;

	retval = ioctl(fds[iIndex], CH37X_SET_TIMEOUT, (unsigned long)&timeout);
	if (retval != 0)
		return false;
	return true;
}

bool CH37XSetBufUpload(
    unsigned long iIndex,       // ָCH37X豸
	unsigned int epnum,         // ָCH37X豸˵
    bool enable)                  // Ϊfalseֹڲϴģʽ,ʹֱϴ,0ڲϴģʽе
{
	bufmode = enable;
    if (enable)
        return ioctl(fds[iIndex], START_BUFFERED_UPLOAD, (unsigned long)&epnum);
    else
        return ioctl(fds[iIndex], STOP_BUFFERED_UPLOAD, (unsigned long)&epnum);
}

static bool CH37XASyncReadData(  
	unsigned long iIndex,       // ָCH37X豸
	unsigned int epnum,         // ָCH37X豸˵
	void *oBuffer,              // ָһ㹻Ļ,ڱȡ
	unsigned long *ioLength)    // ָ򳤶ȵԪ,ʱΪ׼ȡĳ,غΪʵʶȡĳ
{
	int retval = false;
	int len = *ioLength;
	int i = 0;

	struct {
		unsigned long pLength;
		unsigned long epnum;
		unsigned char *r_buf;
	} bulkUp;

	bulkUp.pLength = (unsigned long)&len;
	bulkUp.epnum = (unsigned long)&epnum;
	bulkUp.r_buf = oBuffer;

	retval = ioctl(fds[iIndex], CH37X_BULK_UP, (unsigned long)&bulkUp);
	printf("retval: %d\n", retval);
	if (retval == 0) {
		*ioLength = len;
#ifdef CH37XDEBUG
		printf("Buffer read: %d\n", *ioLength);
		for (i = 0; i < *ioLength; i++)
			printf("0x%.2x ", bulkUp.r_buf[i]);
		printf("\n");
#endif
		return true;
	} else
		return false;
}

static bool CH37XSyncReadData(  
	unsigned long iIndex,       // ָCH37X豸
	unsigned int epnum,         // ָCH37X豸˵
	void *oBuffer,              // ָһ㹻Ļ,ڱȡ
	unsigned long *ioLength)    // ָ򳤶ȵԪ,ʱΪ׼ȡĳ,غΪʵʶȡĳ
{
	int retval = false;
	int len = *ioLength;
	int i = 0;

	struct {
		unsigned long pLength;
		unsigned long epnum;
		unsigned char *r_buf;
	} bulkUp;

	bulkUp.pLength = (unsigned long)&len;
	bulkUp.epnum = (unsigned long)&epnum;
	bulkUp.r_buf = oBuffer;

	retval = ioctl(fds[iIndex], CH37X_BULK_READ, (unsigned long)&bulkUp);
	printf("retval: %d\n", retval);
	if (retval == 0) {
		*ioLength = len;
#ifdef CH37XDEBUG
		printf("Buffer read: %d\n", *ioLength);
		for (i = 0; i < *ioLength; i++)
			printf("0x%.2x ", bulkUp.r_buf[i]);
		printf("\n");
#endif
		return true;
	} else
		return false;
}

// ȡݿ
bool CH37XReadData(  
	unsigned long iIndex,       // ָCH37X豸
	unsigned int epnum,         // ָCH37X豸˵
	void *oBuffer,              // ָһ㹻Ļ,ڱȡ
	unsigned long *ioLength)    // ָ򳤶ȵԪ,ʱΪ׼ȡĳ,غΪʵʶȡĳ
{
	if (bufmode)
	    return CH37XASyncReadData(iIndex, epnum, oBuffer, ioLength);
	else
	    return CH37XSyncReadData(iIndex, epnum, oBuffer, ioLength);
}

// дݿ
static bool CH37XASyncWriteData(
	unsigned long iIndex,       // ָCH37X豸
	unsigned int epnum,         // ָCH37X豸˵
	void *iBuffer,              // ָһ,׼д
	unsigned long *ioLength)    // ָ򳤶ȵԪ,ʱΪ׼дĳ,غΪʵдĳ
{
	int retval = 0;
	int len = *ioLength;
	int i = 0;
	
	struct {
		unsigned long pLength;
		unsigned long epnum;
		unsigned char *w_buf;
	} bulkDown;

	bulkDown.pLength = (unsigned long)&len;
	bulkDown.epnum = (unsigned long)&epnum;
	bulkDown.w_buf = iBuffer;

	retval = ioctl(fds[iIndex], CH37X_BULK_DOWN, (unsigned long)&bulkDown);
	if (retval == 0) {
		*ioLength = len;
#ifdef CH37XDEBUG
		printf("Buffer write: %d\n", *ioLength);
		for (i = 0; i < *ioLength; i++)
			printf("0x%.2x ", bulkDown.w_buf[i]);
		printf("\n");
#endif
		return true;
	} else
		return false;
}


// дݿ
static bool CH37XSyncWriteData(
	unsigned long iIndex,       // ָCH37X豸
	unsigned int epnum,         // ָCH37X豸˵
	void *iBuffer,              // ָһ,׼д
	unsigned long *ioLength)    // ָ򳤶ȵԪ,ʱΪ׼дĳ,غΪʵдĳ
{
	int retval = 0;
	int len = *ioLength;
	int i = 0;
	
	struct {
		unsigned long pLength;
		unsigned long epnum;
		unsigned char *w_buf;
	} bulkDown;

	bulkDown.pLength = (unsigned long)&len;
	bulkDown.epnum = (unsigned long)&epnum;
	bulkDown.w_buf = iBuffer;

	retval = ioctl(fds[iIndex], CH37X_BULK_WRITE, (unsigned long)&bulkDown);
	if (retval == 0) {
		*ioLength = len;
#ifdef CH37XDEBUG
		printf("Buffer write: %d\n", *ioLength);
		for (i = 0; i < *ioLength; i++)
			printf("0x%.2x ", bulkDown.w_buf[i]);
		printf("\n");
#endif
		return true;
	} else
		return false;
}

// ȡݿ
bool CH37XWriteData(  
	unsigned long iIndex,       // ָCH37X豸
	unsigned int epnum,         // ָCH37X豸˵
	void *iBuffer,              // ָһ,׼д
	unsigned long *ioLength)    // ָ򳤶ȵԪ,ʱΪ׼дĳ,غΪʵдĳ
{
	if (bufmode)
	    return CH37XASyncWriteData(iIndex, epnum, iBuffer, ioLength);
	else
	    return CH37XSyncWriteData(iIndex, epnum, iBuffer, ioLength);
}




